export interface StateChangeCallbacks {
    onCrawlingFinished: (crawledUrls: string[]) => void;
}
export default class State {
    visitedUrls: {
        [url: string]: boolean;
    };
    crawledUrls: {
        [url: string]: boolean;
    };
    beingCrawledUrls: string[];
    callbacks: StateChangeCallbacks;
    constructor(callbacks: StateChangeCallbacks);
    clear(): this;
    startedCrawling(url: string): void;
    isBeingCrawled(url: string): boolean;
    rememberVisitedUrls(urls: string[]): void;
    isVisitedUrl(url: string): boolean;
    rememberCrawledUrl(url: string): void;
    finishedCrawling(url: string): void;
}
